def stop_threads(emptyq=True):
    '''Signal running threads that
    they should stop working.

    Threaded commands should cooperate
    by watching for this signal and
    doing the right thing.

    if emptyq True, also clears out
    any pending drawing commands.
    '''

    import threading
    for t in threading.pflags:
        threading.pflags[t] = True

    if emptyq:
        pynguin._empty_move_queue(True)


def kill_threads(emptyq=True):
    import threading
    for t in threading.pflags:
        t.terminate()

    if emptyq:
        pynguin._empty_move_queue(True)
