def arun(cmdname, *args):
    '''Have all pynguins run the named
    command, each in its own separate
    thread. Any additional arguments will
    be passed on to the command.

    cmdname should be a string naming the
    command to be run.

    Looks first to see if cmdname is the name
    of a method of a pynguin, and if not it
    looks for a function with that name in the
    global namespace.

    If cmdname is a function, it should take
    a pynguin as its first argument, other
    supplied args will be added afer.
    '''

    for pyn in pynguins:
        try:
            cmd = getattr(pyn, cmdname)
            trun(cmd, *args)
        except AttributeError:
            cmd = globals().get(cmdname, None)
            if cmd is None:
                continue
            trun(cmd, pyn, *args)
