import os

from PyQt5 import QtCore, QtGui, QtWidgets, uic
from PyQt5.Qt import QFrame, QWidget, QHBoxLayout, QPainter

from . import util
from . import conf

datadir = util.get_datadir()
uidir = os.path.join(datadir, 'ui')

class CustomAvatar(QtWidgets.QDialog):
    def __init__(self, parent):
        self.parent = parent
        QtWidgets.QDialog.__init__(self)
        uifile = 'avatar.ui'
        uipath = os.path.join(uidir, uifile)
        CAClass, _ = uic.loadUiType(uipath)
        self.ui = CAClass()
        self.ui.setupUi(self)
        self.fmt = None

    def browse(self):
        filepath, _ = QtWidgets.QFileDialog.getOpenFileName(
                            self,
                            'Choose image for avatar')
        if filepath:
            self.ui.filepath.setText(filepath)
            fmt = QtGui.QImageReader.imageFormat(filepath)
            if fmt == 'svg':
                self.ui.element.setEnabled(True)
            self.fmt = fmt

    def accept(self):
        if self.fmt == 'svg' and not self.ui.element.text():
            # Must choose an svg element
            QtWidgets.QMessageBox.information(
                    self,
                    'Choose SVG Element',
                    'You must choose an SVG element.')
        else:
            QtWidgets.QDialog.accept(self)
